import re
import sys
import matplotlib.pyplot as plt
import numpy as np
import networkx as nx
import gurobipy as gp
import pyexcel

from gurobipy import GRB

G = nx.DiGraph()



iterate = np.array([0, 10.6, 2, 9])
iterate3 = np.append(iterate,iterate)
iterate4 = np.append(iterate3,iterate)
fasit = np.add.accumulate(iterate4)

num_cyc = int(len(iterate4)/len(iterate))


distanceMatrSimple = np.zeros((len(fasit),len(fasit)))
for i in range(len(fasit)):
    for j in range(len(fasit)):
        tall = np.abs(fasit[i]-fasit[j])
        distanceMatrSimple[i][j] = tall
    


N = np.arange(len(distanceMatrSimple))

Start = N[0]
Slutt = N[-1]


#Bat_alt = [0,1,2,3]
#range_bat = [0,10,20,30] #Tidevind
#range_bat = [0, 11.8,23.6,35.4, 47.2] #Baronessen
#range_bat = [0,8.2,16.4,24.6,32.8,41]  #Baronen

#range_bat = [0,8,16,24] #Tidevind80%DOD
#range_bat = [0, 9.42, 18.84, 28.26, 37.68] #Baronessen80%DOD
#range_bat = [0, 6.53, 13.06, 19.59, 26.12, 32.65] #Baronen80%DOD

#range_bat = 36.6 #Baronen 
#range_bat = 41.48 #Baronessen
range_bat = 30.44 #Tidevind

#cost_bat = np.array([0, 0.25, 0.55, 0.85, 1.15, 1.45 ])

#cost_nm = 0.272067 #Baronen 
#cost_nm = 0.19095 #Baronessen
cost_nm = 0.225 #MNOK/nm[range] TIDEVIND




A = [(i,j) for i in N for j in N if i<j and j!=0] 
S = {(i,j): distanceMatrSimple[i,j] for i,j in A if distanceMatrSimple[i,j] <=range_bat } 


cost = [0]*len(N)#Cost of establishing charging in each port







cost[0] = 1.5/(num_cyc*2)
cost[3] = cost[0]
cost[4] = cost[0]
cost[7] = cost[0]
cost[8] = cost[0]
cost[10] = cost[0]
cost[11] = cost[0]
cost[1] = 1.7/num_cyc
cost[5] = cost[1]
cost[9] = cost[1]
cost[2] = 1.9/num_cyc
cost[6] = cost[2]
cost[10] = cost[2]




arcsData = []
for i,j in S:
    arcsData.append((i,j,S[i,j])) # Data on each of the arcs. For visualization only


pyexcel.save_as(array=distanceMatrSimple, dest_file_name="B20DistanceMatrix.xlsx")

G.add_edges_from(S)

#GUROBI
#The optimization model 

m = gp.Model()
m.update()
x = m.addVars(S, vtype = GRB.BINARY, name = 'x') #declaring variables
#y = m.addVars(N,Bat_alt, vtype = GRB.BINARY, name = 'y') #Variable y no longer needed
u = m.addVars(N, vtype = GRB.BINARY, name = 'u')
w = m.addVars(S, vtype = GRB.BINARY, name = 'w')

batCap = m.addVar(name = 'BatCap', vtype = GRB.CONTINUOUS) #Adding continous variable holding the distance the largest battery must be able of propelling the vessel


m.modelSense = GRB.MINIMIZE 
m.setObjective(gp.quicksum((cost[i])*u[i] for i in N ) + batCap*cost_nm/10  ) 


start_const = []
for a in arcsData:
    if a[0] == Start:
        start_const.append(a)

end_const = []
for a in arcsData:
    if a[1] == Slutt:
        end_const.append(a)

m.addConstrs(w[i,j]-x[i,j] == 0 for i,j in S)
m.addConstrs(w[i,j] >= x[i,j]+u[i]-1 for i,j in S)
m.addConstrs(w[i,j]<= x[i,j] for i,j in S)
m.addConstrs(w[i,j]<= u[i] for i,j in S)



m.addLConstr(gp.quicksum(x[a[0],a[1]] for a in start_const) == 1) 
m.addLConstr(gp.quicksum(x[a[0],a[1]] for a in end_const) == 1) 
m.addConstrs((x[i,j]*S[i,j]<= batCap*0.8 for i,j in S), name='MaxConstraint') # The longest distance between two ports with charging facilities can be 80% of what the battery is capable of propelling the vessel
m.addConstrs((u[i]-u[i+(int(len(N)/num_cyc))]  == 0 for i in N[0:(len(N)-len(iterate))]) )
m.addConstr(u[Start] == u[Slutt])
m.addConstr(batCap <=range_bat) #Maximum allowed range of battery due to weight restrictions


for v in G.nodes:
    if v not in [Start,Slutt]:

        expr1 = gp.quicksum(x[i,v] for i in G.predecessors(v))

        expr2 = gp.quicksum(x[v,j] for j in G.successors(v))

        m.addLConstr(expr1 - expr2 == 0)


m.optimize()

print(m.display())

m.write('test.mps')
if m.Status != GRB.OPTIMAL:
    print('Optimization ended with status %d' % m.Status)
    sys.exit(0)

for v in m.getVars():
    print('%s %g' % (v.VarName, v.X))


print('The Objective value: %g' % m.ObjVal)


result_nodes = []
for v in m.getVars():

    if v.X >= 0.5 and 'x' in v.VarName:
        result_nodes.append(v.varName)


mellomhold = []
for a in result_nodes:
    b = re.findall(r'\d+',a)
    mellomhold.extend(b)

results_vec = []
for b in mellomhold:
    if b.isdigit():
        results_vec.append(int(b))

results_vec = list(sorted(set(results_vec)))
print(results_vec)


battery_data = []
for v in m.getVars():
    if v.X >= 0.5 and 'y' in v.VarName:
        battery_data.append(v.VarName)

mellomhold_bat = []
for a in battery_data:
    b = re.findall(r'\d+',a)
    mellomhold_bat.extend(b)

results_vec_y = []
for b in mellomhold_bat:
    if b.isdigit():
        results_vec_y.append(int(b))

battery_station = results_vec_y[0::2]
batter_choice = results_vec_y[1::2]

for i in range(len(battery_station)):
    print('Port %s will supply vessel with battery %s' %(battery_station[i],batter_choice[i]) )
        
print('The nodes in the solution:',results_vec)








pos = nx.kamada_kawai_layout(G)




options = {'node_color': 'cyan','node_size': 200,'width': 0.5}


plt.figure()
nx.draw(G,pos, with_labels=True, **options)


plt.figure()
nx.draw(G,pos, with_labels=True, **options)
shortPath = [(results_vec[i],results_vec[i-1]) for i in range(len(results_vec)-1,0,-1)]
nx.draw_networkx_edges(G,pos,edgelist=shortPath,width=5,edge_color='red')


print(m.Runtime)

plt.show()

